Prompt .  Grants and synonyms
Set Define "&"
Set Verify Off
Set Feedback Off
Column c_NamesRoot NoPrint New_Value DB_USER_ROOT
Select Pvm_Client.Get_Root As c_NamesRoot From Dual;
Define GUI_BASE_ROLE_NAME      = &DB_USER_ROOT._GUI_BASE_ROLE
Grant Select On TZ_DESC To &GUI_BASE_ROLE_NAME;
Grant Select On TZ_DST_OFFSET To &GUI_BASE_ROLE_NAME;
col clt NoPrint New_Value CLIENT_GUI
select idx_ind clt from CLNT_TYPE
where str_name = 'GUI'
/
col clt NoPrint New_Value CLIENT_RESMGR
select idx_ind clt from CLNT_TYPE
where str_name = 'RESMGR'
/
col clt NoPrint New_Value CLIENT_INVENTORY
select idx_ind clt from CLNT_TYPE
where str_name = 'INVENTORY'
/
Declare
  Cursor curClientGui Is
  Select Str_Ora_User From Clnt_Desc
   Where Idx_Type In (&CLIENT_GUI, &CLIENT_RESMGR, &CLIENT_INVENTORY);
  Procedure Create_One_Syn( P_sOraUser In Varchar2,
                            P_sSynonym In Varchar2,
                            P_sTable   In Varchar2 Default Null )
  Is
    sTable  Varchar2(100);
  Begin
    If P_sTable Is Null Then
      sTable := P_sSynonym;
    Else
      sTable := P_sTable;
    End If;
    Pvm_Utility.Drop_Synonym( P_sOraUser || '.' || P_sSynonym, False );
    Pvm_Utility.Create_Synonym( P_sOraUser || '.' || P_sSynonym,
                                Pvm_Client.Get_Root || '_ADMIN.' || sTable );
  End Create_One_Syn;
Begin
  For recClientGui In curClientGui Loop
    Create_One_Syn( recClientGui.Str_Ora_User, 'TZ_DESC' );
    Create_One_Syn( recClientGui.Str_Ora_User, 'TZ_DST_OFFSET' );
  End Loop;
End;
/
