Set Define "&"
Set Verify Off
Set Feedback Off
Set Head Off
Set Showmode Off
Set Termout Off
Whenever SQLError Exit 1
Declare
  iTZ      Number := 12;
  iLevel   Number := 1;
  iDateNow Number(10) := Pvm_Time.Date2Second(Pvm_Time.Get_GMT_Date);
Begin
  If Not Temp_TZ_Applied Then
    Pvm_Aggset.Reset_All_Aggset;
    Pvm_Config.Set_Working_Key('DATABASE.GENERAL.TZ',
                                True);
    Pvm_Config.Set_Number_Value('PATCH_DATE',
                                Pvm_Time.Date2Second(Pvm_Time.Get_GMT_Date),
                                True,
                                True);
    Pvm_Config.Set_Number_Value('DATABASE.GENERAL.TZ.PATCH_DATE',
                                iDateNow,
                                True,
                                True);
    Pvm_Config.Set_Number_Value('DATABASE.GENERAL.TZ.PATCH_LEVEL',
                                iLevel,
                                True,
                                True);
    Pvm_Config.Set_Number_Value('DATABASE.GENERAL.PATCHES.DB_PATCH_TZ'||iLevel||'.DATE',
                                iDateNow,
                                True,
                                True);
    Pvm_Config.Set_String_Value('DATABASE.GENERAL.PATCHES.DB_PATCH_TZ'||iLevel||'.DESCRIPTION',
                                'Upgrade to TZ level '||iLevel,
                                True,
                                True);
  ElsIf Temp_TZ_Apply_Level_1 Then
      For recAggset In ( Select Idx_Ind
                           From AGGSET_DESC a
                          Where Dte_Date = ( Select Max(Dte_Date)
                                               From AGGSET_DESC a1
                                              Where a1.Idx_Ind = a.Idx_Ind
                                                And Dte_Date < Pvm_Time.Date2Second(Pvm_Time.Get_GMT_Date) )
                            And Dst_Flag = 1
                            And Idx_TZ = iTZ )
      Loop
      dbms_output.put_line ( 'Resetting Aggset '||recAggset.Idx_Ind|| ' for timezone '|| iTZ );
      Pvm_Aggset.Reset_Aggset( iTz, 1, recAggset.Idx_Ind );
      End Loop;
      iTZ := 30;
      For recAggset In ( Select Idx_Ind
                           From AGGSET_DESC a
                          Where Dte_Date = ( Select Max(Dte_Date)
                                               From AGGSET_DESC a1
                                              Where a1.Idx_Ind = a.Idx_Ind
                                                And Dte_Date < Pvm_Time.Date2Second(Pvm_Time.Get_GMT_Date) )
                            And Dst_Flag = 1
                            And Idx_TZ = iTZ )
      Loop
      dbms_output.put_line ( 'Resetting Aggset '||recAggset.Idx_Ind|| ' for timezone '|| iTZ );
      Pvm_Aggset.Reset_Aggset( iTz, 1, recAggset.Idx_Ind );
      End Loop;
      Pvm_Config.Set_Number_Value('DATABASE.GENERAL.TZ.PATCH_DATE',
                                  iDateNow,
                                  True,
                                  True);
      Pvm_Config.Set_Number_Value('DATABASE.GENERAL.TZ.PATCH_LEVEL',
                                  iLevel,
                                  True,
                                  True);
      Pvm_Config.Set_Number_Value('DATABASE.GENERAL.PATCHES.DB_PATCH_TZ'||iLevel||'.DATE',
                                  iDateNow,
                                  True,
                                  True);
      Pvm_Config.Set_String_Value('DATABASE.GENERAL.PATCHES.DB_PATCH_TZ'||iLevel||'.DESCRIPTION',
                                  'Upgrade to TZ level '||iLevel,
                                  True,
                                  True);
  End If;
End;
/
